> ## Documentation Index
> Fetch the complete documentation index at: https://docs.anglpay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Capture transaction

This endpoint requires the `transactions.write` scope.


## OpenAPI

````yaml openapi.speakeasy.json POST /transactions/{transaction_id}/capture
openapi: 3.0.0
info:
  title: Gr4vy API
  version: 1.1.0-beta
  contact:
    name: Gr4vy Support
    email: code@gr4vy.com
    url: https://gr4vy.com
  termsOfService: https://gr4vy.com
  license:
    name: MIT
    url: https://raw.githubusercontent.com/gr4vy/gr4vy-openapi/main/LICENSE
  description: |-
    Welcome to the Gr4vy API reference documentation.
    Our API is still very much a work in product and subject to change.
servers:
  - url: https://api.sandbox.{id}.gr4vy.app
    x-speakeasy-server-id: sandbox
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
  - url: https://api.{id}.gr4vy.app
    x-speakeasy-server-id: production
    variables:
      id:
        default: example
        description: The subdomain for your Gr4vy instance.
security:
  - bearerAuth: []
tags:
  - name: Account Updater
    description: >-
      An Account Updater is a service provided by credit card issuers

      (such as banks and financial institutions) to merchants who accept

      recurring payments from customers. Its primary purpose is to help

      merchants maintain accurate and up-to-date payment information for

      their customers' credit or debit card accounts.


      In Gr4vy, the Account Updater service is provided in an on-demand

      and asynchronous fashion:


      1. A merchant requests an update for a set of stored cards.

      2. A request is submitted to a third-party service.

      3. When results are ready, new card details are stored and left in
      standby.

      4. Card details are updated when it gets determined that the original card
         is no longer valid (e.g. has expired).
  - name: Anti-Fraud Services
    description: >-
      In Gr4vy, an anti-fraud service represents a configured anti-fraud service

      provider (`Sift`, `CyberSource`, etc). This third-party services will be

      used to screen transactions to determine the risk and prevents chargebacks

      and fraudulent transactions.


      The anti-fraud services API can be used to:


      * Provide Gr4vy with the API credentials for an anti-fraud service
      provider.

      * Set a display name for a anti-fraud provider.

      * Map anti-fraud service decisions to Gr4vy internal decisions.
    x-internal: true
  - name: Anti Fraud Service Definitions
    description: >-
      Anti fraud service definitions describe the fields required for a anti
      fraud

      service to be configured.
  - name: API Key Pairs
    description: >-
      In Gr4vy, an API key pair is used to sign and validate JSON Web Tokens
      (JWT).

      JWTs are used as a HTTP `bearer` token to authenticate to the API. For
      more

      information please visit our [in-depth
      authentication](/guides/authentication)

      guide.
    x-internal: true
  - name: API Logs
    description: >-
      API Logs provide an historic of 4XX and 5XX errors that happened in the
      API

      in the last 24 hours with a 250 result limit.
    x-internal: true
  - name: Apple Pay Certificates
    description: >-
      Apple Pay payment processing certificates are used by Apple to encrypt
      Apple

      Pay tokens. You must register and upload an Apple Pay payment processing

      certificate if you wish to use Apple Pay with Gr4vy's mobile SDKs.


      The Apple Pay certificates API can be used to:


      * Start a new Apple Pay certificate registration, providing you with a

      Certificate Signing Request (CSR).

      * Update the Apple Pay certificate record with the certificate received
      from

      Apple after creating a new payment processing certificate on your Apple

      Developer console and uploading a CSR.

      * List all Apple Pay certificates.
    x-internal: true
  - name: Audit Logs
    description: >-
      Audit Logs provide an historic record of changes made to your Gr4vy
      instance.
  - name: Buyers
    description: >-
      In Gr4vy, a buyer represents your customer, the shopper who's performing

      a checkout and making a purchase.


      A buyer can be used by you to:


      * Display a human readable name (`display_name`) for a buyer in the Gr4vy

      admin panel

      * Associate multiple stored payment methods with a single user

      * Initialize **Gr4vy Embed** with the buyer ID, automatically displaying
      the
        buyer's previously stored payment methods, allowing for faster checkout.
  - name: Card Details
    description: Endpoints to retrieve details of a card by utilising a BIN lookup table.
    x-internal: true
  - name: Card Scheme Definitions
    description: Card Scheme definitions provide display information to a card scheme.
  - name: Connections
    description: |-
      Endpoints to retrieve details of configured connections such as payment
      services, digital wallets, and anti-fraud services.
    x-internal: true
  - name: Connection Definitions
    description: |-
      Endpoints to retrieve details of various connections such as payment
      services, digital wallets, and anti-fraud services.
    x-internal: true
  - name: Checkout Sessions
    description: |-
      A Checkout Session represents the session of a user as they progress
      through an online checkout.
  - name: Digital Wallets
    description: |-
      In Gr4vy, a digital wallet represents a way for a buyer to pay using
      card details already stored on their device via a digital wallet service
      such as Apple Pay or Google Pay. The buyer will not have to fill in their
      card details on checkout.

      The digital wallets API can be used to:

      * Register with a digital wallet provider.
      * List digital wallets currently registered.
  - name: Gift Cards
    description: >-
      In Gr4vy, a gift card represents a stored value card that can be used to
      pay for

      a transaction.
  - name: Gift Card Services
    description: >-
      In Gr4vy, a gift card service represents a configured provider for
      processing

      gift cards.
  - name: Gift Card Service Definitions
    description: |-
      Gift card service definitions describe the fields required for a gift
      card service to be configured.
  - name: Health Dashboard
    description: Endpoints to retrieve the data used for the Health Dashboard.
    x-internal: true
  - name: Merchant Accounts
    description: |-
      In Gr4vy, a merchant account represents an individual merchant in an
      instance. Each instance has one or more merchant accounts, and each
      merchant account has its own connections, Flow rules, transactions, and
      more.
  - name: Metrics Explorer
    description: Endpoints to retrieve the data used for the Metrics Explorer.
    x-internal: true
  - name: Payment Methods
    description: |-
      In Gr4vy, a payment method represents a way in which a payment can be
      processed, for example a card, a PayPal account, or a bank account.

      The payment method API can be used to:

      * List all the available payment methods
      * Filter the available payment method for a buyer in a specific currency
      and country.
      * Store (also known as vault) a payment method for a buyer.
      * Fetch all previously stored payment methods for a buyer.
  - name: Payment Method Definitions
    description: >-
      Payment Method definitions provide display information to a payment
      method.
  - name: Payment Options
    description: |-
      In Gr4vy, a payment option represents a list of methods (card, PayPal,
      etc) that are available for a given locale.

      The payment options API can be used to:

      * Determine what types of payments can be processed in a specific locale.
      * Display a list options to a buyer to choose from.
  - name: Payment Service Definitions
    description: |-
      Payment service definitions describe the fields required for a payment
      service to be configured.
  - name: Payment Services
    description: |-
      In Gr4vy, a payment service represents a configured payment provider
      (Stripe, PayPal, Adyen, etc) for a specific payment type (card, bitcoin,
      etc)

      The payment services API can be used to:

      * Provide Gr4vy with the payment credentials for a payment provider.
      * Set a display name for a payment provider.
  - name: Payouts
    description: |-
      Payouts allow a merchant to send money from one of their own accounts to a
      third party.
  - name: Payment Links
    description: >-
      In Gr4vy, payment links allow a merchant to generate a link, send it to a

      customer via email, SMS, etc, and then have the customer pay without the
      need

      for the merchant hosting their own checkout.
  - name: Vault Forward Definitions
    description: >-
      Vault Forward definitions describe a third party service that has been
      vetted

      to receive requests containing PCI data.
  - name: Vault Forward Configurations
    description: |-
      A Vault Forward Configuration represents a third party service that is
      currently enabled to send requests containing PCI data.
  - name: Vault Forward
    description: |-
      Vault Forwarding is a way to perform requests where, provided a template,
      Gr4vy will evaluate it to inject PCI data and forward it to third party
      services that have been vetted to receive such data.
  - name: Reports
    description: |-
      In Gr4vy, a report represents the configuration details to extract or
      dump a set of data into a downloadable CSV file. The data extracted
      by a report is configured via the reports API where you can specify:

      * Which fields should be in the dataset.
      * How the dataset should be sorted.
      * How the dataset should be filtered.

      Once a report is created, it may be executed on a one-off or recurring
      basis. One-off reports are executed only once shortly after the report
      is created, while recurring reports are executed periodically based on
      its configured frequency, e.g. weekly or monthly.

      During a report execution, the data is extracted and loaded into
      a CSV file according to the report's configuration. The resulting file
      may then be downloaded.

      The reports API can be used to:

      * Create and configure new reports.
      * List all reports.
      * View the configuration details of a report.
      * List a report's executions.
      * Reconfigure an existing report.
      * Generate a temporary URL to download the result of a report execution
      in CSV format.
  - name: Sessions
    description: |-
      The sessions APIs are used to facilitate user authentication for the Gr4vy
      dashboard.
    x-internal: true
  - name: Transactions
    description: >-
      In Gr4vy, a transaction represents a payment in any state, either before
      it

      is authorized, once it is captured, or after it has been refunded.


      The transactions API can be used to:


      - Authorize, capture, and store cards.

      - Authorize, capture, and store alternative payment methods like PayPal.

      - Refund, void, and otherwise cancel existing transactions.
  - name: Users
    description: |-
      In Gr4vy, a user represents an employee of the merchant with access to the
      dashboard.
    x-internal: true
  - name: Webhooks
    description: |-
      Endpoints related to webhooks to integrate Gr4vy with payment services
      webhooks functionality.
    x-internal: true
  - name: Flow
    description: >-
      In Gr4vy, a rule can be created that triggers actions anywhere in the
      payment flow.
    x-internal: true
  - name: Roles
    description: >-
      In Gr4vy, users can be granted access to specific types of resources and
      permissions

      to perform certain actions by being assigned one or more roles.
  - name: Tokens
    description: Endpoints related to the Gr4vy tokenization service.
  - name: Webhook subscriptions
    description: >-
      Endpoints related to the management of subscriptions for endpoints to
      receive webhooks.
paths:
  /transactions/{transaction_id}/capture:
    parameters:
      - schema:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
        name: transaction_id
        in: path
        required: true
        description: The ID for the transaction to get the information for.
    post:
      tags:
        - Transactions
      summary: Capture transaction
      description: Captures a previously authorized transaction.
      operationId: capture-transaction
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/TransactionCaptureRequest'
            examples:
              Capture an authorization:
                value:
                  amount: 1299
      responses:
        '200':
          description: Returns the captured transaction.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Transaction'
        '400':
          description: >-
            Returns an error if the request was badly formatted or missing
            required fields.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error400BadRequest'
        '401':
          description: Returns an error if no valid authentication was provided.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error401Unauthorized'
        '404':
          description: >-
            Returns an error if the resource can not be found or has not yet
            been created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error404NotFound'
components:
  schemas:
    TransactionCaptureRequest:
      title: Capture a transaction
      type: object
      description: A request to capture a transaction.
      x-tags:
        - Request Bodies
      properties:
        amount:
          type: integer
          description: >-
            The monetary amount to capture an authorization for, in the smallest

            currency unit for the given currency, for example `1299` cents to
            create

            an authorization for `$12.99`.


            When omitted blank, this will capture the entire amount.
          example: 1299
          minimum: 1
          maximum: 99999999
        airline:
          type: object
          allOf:
            - $ref: '#/components/schemas/Airline'
          description: >-
            The airline addendum data which describes the airline booking

            associated with this transaction. When provided, this will override
            any

            airline data provided when authorizing the transaction. Only the
            data on

            this request will be passed to the payment service, and none of the

            original data will be sent or kept.
          nullable: true
    Transaction:
      title: Transaction
      type: object
      description: A transaction record.
      x-tags:
        - Transactions
      properties:
        type:
          type: string
          description: The type of this resource. Is always `transaction`.
          example: transaction
          enum:
            - transaction
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique identifier for this transaction.
          format: uuid
        amount:
          description: |-
            The total amount for this transaction across all funding sources
            including gift cards.
          example: 1299
          maximum: 99999999
          minimum: 0
          type: integer
        additional_identifiers:
          description: >-
            A list of additional identifiers that we may keep track of to manage
            this transaction. This

            may include the authorization ID, capture ID, and processor ID, as
            well as an undefined list of

            additional identifiers.
          allOf:
            - $ref: '#/components/schemas/AdditionalIdentifiers'
        auth_response_code:
          description: This is the response description received from the processor.
          example: '00'
          nullable: true
          type: string
        authorized_amount:
          description: >-
            The amount for this transaction that has been authorized for the
            `payment_method`.

            This can be less than the `amount` if gift cards were used.
          example: 1299
          maximum: 99999999
          minimum: 0
          type: integer
        authorized_at:
          description: >-
            The date and time when this transaction was authorized in the
            payment

            service.


            Don't use this field to determine whether the transaction was
            authorized.

            A `null` value doesn't necessarily imply that the transaction wasn't

            authorized, it can mean that the payment service doesn't provide
            this

            value, that it didn't provide it at the time the transaction was

            authorized or that the transaction was authorized before the
            introduction

            of this field.
          example: '2013-07-16T19:23:00.000+00:00'
          format: date-time
          nullable: true
          type: string
        approval_expires_at:
          description: >-
            The date and time when this transaction will be marked as failed if
            it does

            not successfully gets captured, authorized or otherwise approved
            before.
          example: '2013-07-16T19:23:00.000+00:00'
          format: date-time
          nullable: true
          type: string
        avs_response_code:
          type: string
          description: >-
            The response code received from the payment service for the Address

            Verification Check (AVS). This code is mapped to a standardized
            Gr4vy

            AVS response code.


            - `no_match` - neither address or postal code match

            - `match` - both address and postal code match

            - `partial_match_address` - address matches but postal code does not

            - `partial_match_postcode` - postal code matches but address does
            not

            - `unavailable ` - AVS is unavailable for card/country


            The value of this field can be `null` if the payment service did not

            provide a response.
          example: partial_match_address
          nullable: true
          enum:
            - no_match
            - match
            - partial_match_address
            - partial_match_postcode
            - unavailable
        buyer:
          allOf:
            - $ref: '#/components/schemas/Buyer--Snapshot'
          description: The buyer used for this transaction.
          nullable: true
        captured_amount:
          description: |-
            The captured amount for this transaction. This can be the full value
            of the `authorized_amount` or less.
          example: 999
          maximum: 99999999
          minimum: 0
          type: integer
        captured_at:
          description: >-
            The date and time when this transaction was captured in the payment

            service.


            Don't use this field to determine whether the transaction was
            captured.

            A `null` value doesn't necessarily imply that the transaction wasn't

            captured, it can mean that the payment service doesn't provide this
            value,

            that it didn't provide it at the time the transaction was captured
            or that

            the transaction was captured before the introduction of this field.
          example: '2013-07-16T19:23:00.000+00:00'
          format: date-time
          nullable: true
          type: string
        cart_items:
          description: >-
            An array of cart items that represents the line items of a
            transaction.
          items:
            $ref: '#/components/schemas/CartItem'
          maxLength: 249
          type: array
        checkout_session_id:
          description: >-
            The identifier for the checkout session this transaction is
            associated with.
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          format: uuid
          nullable: true
          type: string
        country:
          description: >
            The 2-letter ISO code of the country of the transaction.

            This is used to filter the payment services that is used to process
            the

            transaction.
          example: US
          type: string
          nullable: true
        created_at:
          type: string
          description: The date and time when this transaction was created in our system.
          format: date-time
          example: '2013-07-16T19:23:00.000+00:00'
        currency:
          description: The currency code for this transaction.
          example: USD
          type: string
        cvv_response_code:
          description: >-
            The response code received from the payment service for the Card

            Verification Value (CVV). This code is mapped to a standardized
            Gr4vy

            CVV response code.


            - `no_match` - the CVV does not match the expected value

            - `match` - the CVV matches the expected value

            - `unavailable ` - CVV check unavailable for card our country

            - `not_provided ` - CVV not provided


            The value of this field can be `null` if the payment service did not

            provide a response.
          enum:
            - no_match
            - match
            - unavailable
            - not_provided
          example: match
          nullable: true
          type: string
        error_code:
          description: This is an error code set by Gr4vy.
          example: missing_redirect_url
          nullable: true
          type: string
        external_identifier:
          description: >-
            An external identifier that can be used to match the transaction
            against your own records.
          example: user-789123
          nullable: true
          type: string
        gift_card_service:
          allOf:
            - $ref: '#/components/schemas/GiftCardService--Snapshot'
          description: The gift card service used for this transaction.
        gift_card_redemptions:
          description: The gift cards redeemed for this transaction.
          items:
            $ref: '#/components/schemas/GiftCardRedemption'
          type: array
        instrument_type:
          nullable: true
          type: string
          description: |
            The name of the instrument used to process the transaction.
          enum:
            - applepay
            - card_token
            - googlepay
            - network_token
            - pan
            - redirect
            - redirect_token
          example: network_token
        intent:
          description: |-
            The original `intent` used when the transaction was
            [created](#operation/authorize-new-transaction).
          enum:
            - authorize
            - capture
          example: authorize
          type: string
        intent_outcome:
          description: >-
            The outcome of the original intent of a transaction.


            This allows you to understand if the intent of the transaction

            (e.g. `capture` or `authorize`) has been achieved when dealing with
            multiple

            payment instruments.


            If all payment instruments (`payment_method` and/or `gift_cards`)

            have succeeded to get an authorization or direct sale **at any point

            in time** then this will return a `succeeded` value.


            If any of the payment instruments fails or declines then this will

            return a `failed` value.


            If any payment instruments is still in a `pending` or `processing`
            state

            then the result will be `pending`.


            Please note that if any of the payment instruments are voided or
            refunded

            after the result reaches a `succeeded` state  then the result will
            remain

            unchanged.
          enum:
            - pending
            - succeeded
            - failed
          example: pending
          type: string
        is_subsequent_payment:
          default: false
          description: >-
            Indicates whether the transaction represents a subsequent payment

            coming from a setup recurring payment.

            Please note there are some restrictions on how this flag may be

            used.


            The flag can only be `false` (or not set) when the transaction meets

            one of the following criteria:


            * It is not `merchant_initiated`.

            * `payment_source` is set to `card_on_file`.


            The flag can only be set to `true` when the transaction meets one of
            the

            following criteria:


            * It is not `merchant_initiated`.

            * `payment_source` is set to `recurring` or `installment` and

            `merchant_initiated` is set to `true`.

            * `payment_source` is set to `card_on_file`.
          example: true
          type: boolean
        merchant_account_id:
          description: The ID of the merchant account to which this transaction belongs to.
          example: default
          maximum: 22
          minimum: 1
          type: string
        merchant_initiated:
          default: false
          description: >-
            Indicates whether the transaction was initiated by the merchant
            (true)

            or customer (false).
          example: true
          type: boolean
        metadata:
          additionalProperties:
            type: string
          description: >-
            Additional information about the transaction stored as key-value
            pairs.
          example:
            key: value
          type: object
        method:
          nullable: true
          type: string
          example: card
          enum:
            - affirm
            - afterpay
            - alipay
            - alipayhk
            - applepay
            - bacs
            - bancontact
            - banked
            - becs
            - bitpay
            - boleto
            - boost
            - card
            - cashapp
            - chaseorbital
            - checkout-session
            - clearpay
            - click-to-pay
            - dana
            - dcb
            - dlocal
            - ebanx
            - efecty
            - eps
            - everydaypay
            - gcash
            - gem
            - gemds
            - gift-card
            - giropay
            - givingblock
            - gocardless
            - googlepay
            - googlepay_pan_only
            - gopay
            - grabpay
            - id
            - ideal
            - kakaopay
            - kcp
            - klarna
            - latitude
            - latitudeds
            - laybuy
            - linepay
            - linkaja
            - maybankqrpay
            - mercadopago
            - multibanco
            - multipago
            - netbanking
            - network-token
            - oney_3x
            - oney_4x
            - oney_6x
            - oney_10x
            - oney_12x
            - ovo
            - oxxo
            - payid
            - paymaya
            - paypal
            - paypalpaylater
            - payto
            - venmo
            - pix
            - pse
            - rabbitlinepay
            - razorpay
            - scalapay
            - sepa
            - shopeepay
            - singteldash
            - smartpay
            - sofort
            - spei
            - stripedd
            - thaiqr
            - touchngo
            - truemoney
            - trustly
            - trustlyeurope
            - upi
            - vipps
            - waave
            - webpay
            - wechat
            - zippay
        multi_tender:
          description: >-
            Defines if this transaction has been split across multiple payment
            instruments

            such as a `payment_method` and one or more `gift_cards`, or multiple
            `gift_cards`

            without a `payment_method`.
          example: true
          type: boolean
        payment_method:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod--Snapshot'
          description: The payment method used for this transaction.
          nullable: true
        payment_service:
          allOf:
            - $ref: '#/components/schemas/PaymentService--Snapshot'
          description: The payment service used for this transaction.
          nullable: true
        payment_service_transaction_id:
          description: The payment service's unique ID for the transaction.
          example: charge_xYqd43gySMtori
          type: string
        payment_source:
          description: The source of the transaction. Defaults to `ecommerce`.
          type: string
          example: recurring
          enum:
            - ecommerce
            - moto
            - recurring
            - installment
            - card_on_file
        pending_review:
          description: Whether a manual review is pending.
          example: true
          nullable: false
          type: boolean
        anti_fraud_decision:
          description: >-
            The mapped decision received from the anti-fraud service. In case of
            a

            review decision this field is not updated once the review is
            resolved.
          nullable: true
          type: string
          example: accept
          enum:
            - accept
            - error
            - exception
            - reject
            - review
            - skipped
        raw_response_code:
          type: string
          description: |-
            This is the response code received from the payment service. This
            can be set to any value and is not standardized across different
            payment services.
          example: incorrect-zip
          nullable: true
        raw_response_description:
          type: string
          description: >-
            This is the response description received from the payment service.
            This

            can be set to any value and is not standardized across different

            payment services.
          example: >-
            The card's postal code is incorrect. Check the card's postal code or
            use a

            different card.
          nullable: true
        reconciliation_id:
          description: >-
            The base62 encoded transaction ID. This represents a shorter version

            of this transaction's `id` which is sent to payment services,
            anti-fraud services,

            and other connectors. You can use this ID to reconcile a payment
            service's

            transaction against our system.


            This ID is sent instead of the transaction ID because not all
            services

            support 36 digit identifiers.
          example: 7jZXl4gBUNl0CnaLEnfXbt
          type: string
        refunded_amount:
          description: |-
            The refunded amount for this transaction. This can be the full value
            of the `captured_amount` or less.
          example: 100
          maximum: 99999999
          minimum: 0
          type: integer
        scheme_transaction_id:
          default: null
          description: |-
            An identifier for the transaction used by the scheme itself, when
            available.

            e.g. the Visa Transaction Identifier, or Mastercard Trace ID.
          example: '123456789012345'
          nullable: true
          type: string
        shipping_details:
          allOf:
            - $ref: '#/components/schemas/ShippingDetail'
          description: The shipping details associated with the transaction.
          nullable: true
        statement_descriptor:
          allOf:
            - $ref: '#/components/schemas/StatementDescriptor'
          nullable: true
        status:
          description: |-
            The status of the transaction for the `payment_method`. The status
            may change over time as asynchronous processing events occur.

            Please note that the possible statuses returned will depend on the
            operation performed. For example, a captured transaction will never
            move to a `authorization_voided` status.
          enum:
            - processing
            - buyer_approval_pending
            - authorization_succeeded
            - authorization_failed
            - authorization_declined
            - capture_pending
            - capture_succeeded
            - authorization_void_pending
            - authorization_voided
          example: processing
          type: string
        three_d_secure:
          $ref: '#/components/schemas/ThreeDSecureSummary'
        airline:
          description: Contains information about an airline travel, if applicable.
          allOf:
            - $ref: '#/components/schemas/Airline'
          nullable: true
        updated_at:
          description: Defines when the transaction was last updated.
          example: '2013-07-16T19:23:00.000+00:00'
          format: date-time
          type: string
        voided_at:
          description: >-
            The date and time when this transaction was voided in the payment
            service.


            Don't use this field to determine whether the transaction was
            voided.

            A `null` value doesn't necessarily imply that the transaction wasn't

            voided, it can mean that the payment service doesn't provide this
            value,

            that it didn't provide it at the time the transaction was voided or
            that

            the transaction was voided before the introduction of this field.
          example: '2013-07-16T19:23:00.000+00:00'
          format: date-time
          nullable: true
          type: string
        settled_currency:
          description: |-
            The currency of this transaction's settlement in
            ISO 4217 three-letter code format.
          example: GBP
          nullable: true
          type: string
        settled_amount:
          description: The net amount settled for this transaction.
          example: 1000
          type: integer
        settled:
          description: Indicates whether this transaction has been settled.
          example: true
          type: boolean
        account_funding_transaction:
          type: boolean
          default: false
          description: Whether or not the transaction is an account funding transaction.
          nullable: true
          example: true
        recipient:
          type: object
          allOf:
            - $ref: '#/components/schemas/Recipient--Snapshot'
          description: The recipient of an account funding transaction.
          nullable: true
        merchant_advice_code:
          type: string
          description: >-
            The merchant advice code received from the payment service. This
            code is

            used to provide additional information about the card used.
          nullable: true
          example: '01'
    Error400BadRequest:
      title: Bad Request
      type: object
      description: Bad Request (HTTP 400).
      x-tags:
        - Errors
      properties:
        type:
          type: string
          description: '`error`.'
          enum:
            - error
          example: error
        code:
          type: string
          description: A short code that describes the reason for the error.
          example: bad_request
          enum:
            - bad_request
            - incorrect_json
            - invalid_credentials
        status:
          type: integer
          description: '`400`.'
          example: 400
          enum:
            - 400
        message:
          type: string
          description: A human-readable reason for the error.
          example: Missing '****' field
        details:
          type: array
          description: >-
            A list of detail objects that further clarify the reason for the
            error.
          items:
            $ref: '#/components/schemas/ErrorDetail'
    Error401Unauthorized:
      title: Unauthorized Error
      type: object
      description: Unauthorized Error (HTTP 401).
      x-tags:
        - Errors
      properties:
        type:
          type: string
          description: '`error`.'
          enum:
            - error
          example: error
        code:
          type: string
          description: '`unauthorized`.'
          example: unauthorized
          enum:
            - unauthorized
        status:
          type: integer
          description: '`401`.'
          example: 401
          enum:
            - 401
        message:
          type: string
          description: No valid API authentication found.
          example: No valid API authentication found
          enum:
            - No valid API authentication found
        details:
          type: array
          description: >-
            A list of detail objects that further clarify the reason for the
            error.

            Not every error supports more detail.
          example: []
          items:
            $ref: '#/components/schemas/ErrorDetail'
    Error404NotFound:
      title: Not Found Error
      type: object
      description: Not Found Error (HTTP 404).
      x-tags:
        - Errors
      properties:
        type:
          type: string
          description: '`error`.'
          enum:
            - error
          example: error
        code:
          type: string
          description: The reason code for the error.
          example: not_found
          enum:
            - not_found
            - pending_creation
        status:
          type: integer
          description: '`404`.'
          example: 404
          enum:
            - 404
        message:
          type: string
          description: The human readable reason for the error.
          example: The resource could not be found
        details:
          type: array
          description: >-
            A list of detail objects that further clarify the reason for the
            error.

            Not every error supports more detail.
          example: []
          items:
            $ref: '#/components/schemas/ErrorDetail'
    Airline:
      title: Airline Addendum
      type: object
      description: Information about an airline travel.
      properties:
        passenger_name_record:
          type: string
          minLength: 1
          maxLength: 50
          description: The Passenger Name Record (PNR) in the airline reservation system.
          example: JOHN L
          nullable: true
        booking_code:
          type: string
          minLength: 1
          maxLength: 50
          description: >-
            The unique identifier of the reservation in the global distribution
            system.
          example: X36Q9C
          nullable: true
        ticket_number:
          type: string
          minLength: 1
          maxLength: 50
          description: The airline's unique ticket number.
          example: 123-1234-151555
          nullable: true
        ticket_delivery_method:
          type: string
          enum:
            - electronic
            - other
          default: electronic
          description: The delivery method of the ticket.
          example: other
          nullable: true
        issued_at:
          type: string
          format: date-time
          description: |-
            The date that the ticket was last issued in the airline reservation
            system.
          example: '2013-07-16T19:23:00.000+00:00'
          nullable: true
        issued_address:
          type: string
          minLength: 1
          maxLength: 255
          description: The address of the place/agency that issued the ticket.
          example: 123 Broadway, New York
          nullable: true
        travel_agency_code:
          type: string
          minLength: 1
          maxLength: 50
          description: The IATA travel agency code.
          example: '12345'
          nullable: true
        travel_agency_name:
          type: string
          minLength: 1
          maxLength: 200
          description: The name of the travel agency.
          example: Agency name
          nullable: true
        travel_agency_invoice_number:
          type: string
          minLength: 1
          maxLength: 50
          description: |-
            The reference number of the invoice that was issued by the
            travel agency.
          example: EG15555155
          nullable: true
        travel_agency_plan_name:
          type: string
          minLength: 1
          maxLength: 200
          description: The name of the travel agency plan.
          example: B733
          nullable: true
        restricted_ticket:
          type: boolean
          description: Indicates whether the ticket is restricted (refundable).
          example: false
          nullable: true
        issuing_carrier_code:
          type: string
          minLength: 2
          maxLength: 3
          description: >-
            For airline aggregators, two-character IATA code of the airline
            issuing

            the ticket.
          example: A3
          nullable: true
        issuing_carrier_name:
          type: string
          minLength: 1
          maxLength: 100
          description: The name of the airline issuing the ticket.
          example: Aegean Airlines
          nullable: true
        issuing_iata_designator:
          type: string
          minLength: 2
          maxLength: 2
          description: 2 character IATA code of the airline issuing the ticket.
          example: A3
          nullable: true
        issuing_icao_code:
          type: string
          minLength: 3
          maxLength: 3
          description: 3 character ICAO code of the airline issuing the ticket.
          example: AEE
          nullable: true
        reservation_system:
          type: string
          minLength: 1
          maxLength: 200
          description: The name of the reservation system.
          example: Amadeus
          nullable: true
        is_cardholder_traveling:
          type: boolean
          description: Indicates whether the cardholder is present in the flight.
          example: false
          nullable: true
        passengers:
          description: An array of the travelling passengers.
          items:
            $ref: '#/components/schemas/AirlinePassenger'
          maxLength: 20
          type: array
          nullable: true
        legs:
          description: |-
            An array of separate trip segments. Each leg contains detailed
            itinerary information.
          items:
            $ref: '#/components/schemas/AirlineLeg'
          maxLength: 20
          type: array
          nullable: true
    AdditionalIdentifiers:
      title: Additional transaction identifiers.
      type: object
      description: >-
        A list of additional identifiers that we may keep track of to manage
        this transaction. This

        may include the authorization ID, capture ID, and processor ID, as well
        as an undefined list of

        additional identifiers.
      x-tags:
        - Transactions
      example:
        payment_service_authorization_id: authorization-1234
        payment_service_capture_id: null
        payment_service_processor_id: null
        another_id: id-1234
      properties:
        payment_service_authorization_id:
          type: string
          example: authorization-1234
          description: >-
            The optional ID for the authorization of this transaction.
            Availability of this ID will vary per connector used.
          nullable: true
        payment_service_capture_id:
          type: string
          example: capture-1234
          description: >-
            The optional ID for the capture of this transaction. Availability of
            this ID will vary per connector used.
          nullable: true
        payment_service_processor_id:
          type: string
          example: processor-1234
          description: >-
            The optional ID provided by the processor for this transaction.
            Availability of this ID will vary per connector used.
          nullable: true
      additionalProperties:
        type: string
    Buyer--Snapshot:
      title: Buyer (Snapshot)
      type: object
      description: |-
        Snapshot of a buyer, as used when embedded inside other
        resources.
      x-tags:
        - Buyers
      properties:
        type:
          type: string
          description: The type of this resource. Is always `buyer`.
          example: buyer
          enum:
            - buyer
        id:
          type: string
          example: fe26475d-ec3e-4884-9553-f7356683f7f9
          description: The unique Gr4vy ID for this buyer.
          format: uuid
          nullable: true
        billing_details:
          allOf:
            - $ref: '#/components/schemas/BillingDetails'
          description: |-
            The billing details associated with the buyer, which include the
            address and tax ID.
          nullable: true
        display_name:
          description: >-
            A unique name for this buyer which is used in the Gr4vy admin panel
            to give a buyer a human readable name.
          example: John L.
          maxLength: 200
          minLength: 1
          nullable: true
          type: string
        external_identifier:
          description: >-
            An external identifier that can be used to match the buyer against
            your own records.
          example: user-789123
          maxLength: 200
          minLength: 1
          nullable: true
          type: string
        account_number:
          type: string
          minLength: 1
          maxLength: 255
          example: '1234567'
          description: The source account number to perform an account funding transaction.
          nullable: true
    CartItem:
      title: Cart Item
      type: object
      description: >-
        A cart item that represents a single cart line item for a transaction.

        Note that some optional properties are required for certain payment

        service providers. If no value is set for these properties, we will use

        their default value.


        If the total due to be paid for the item is required by the payment
        service

        provider, generally referred to as the "total amount", the formula below

        will usually be used to calculate this amount:


        `(unit_amount * quantity) - discount_amount + tax_amount`


        It's highly recommended that the total amount to pay for all items

        should match the transaction's amount to reduce the risk of the

        transaction being declined by the payment service provider.
      required:
        - name
        - quantity
        - unit_amount
      properties:
        name:
          type: string
          description: |-
            The name of the cart item. The value you set for this property may
            be truncated if the maximum length accepted by a payment service
            provider is less than 255 characters.
          example: GoPro HERO9 Camcorder
          maxLength: 255
        quantity:
          type: integer
          description: |-
            The quantity of this item in the cart. This value cannot be negative
            or zero.
          example: 1
          minimum: 1
          maximum: 99999999
        unit_amount:
          type: integer
          description: |-
            The amount for an individual item represented as a monetary amount
            in the smallest currency unit for the given currency, for example
            `1299` USD cents represents `$12.99`.
            The amount sent through to the payment processor as unitary amount
            will be calculated to include the discount and tax values sent
            as part of this cart item.
          example: 37999
          minimum: 0
          maximum: 99999999
        discount_amount:
          type: integer
          description: >-
            The amount discounted for this item represented as a monetary amount

            in the smallest currency unit for the given currency, for example
            `1299`

            USD cents represents `$12.99`.


            Please note that this amount is for the total of the cart item and
            not

            for an individual item. For example, if the quantity is 5, this
            value

            should be the total discount amount for 5 of the cart item.


            You might see unexpected failed transactions if the
            `discount_amount` can

            not be equally divided by the `quantity` value. This is due to the
            fact

            that some payment services require this amount to be specified per
            unit.


            In this situation we recommend splitting this item into separate
            items,

            each with their own specific discount.
          example: 0
          minimum: 0
          maximum: 99999999
          nullable: true
          default: 0
        tax_amount:
          type: integer
          description: >-
            The tax amount for this item represented as a monetary amount

            in the smallest currency unit for the given currency, for example
            `1299`

            USD cents represents `$12.99`.


            Please not that this amount is for the total of the cart item and
            not

            for an individual item. For example, if the quantity is 5, this
            value

            should be the total tax amount for 5 of the cart item.


            You might see unexpected failed transactions if the `tax_amount` can

            not be equally divided by the `quantity` value. This is due to the
            fact

            that some payment services require this amount to be specified per
            unit.


            In this situation we recommend splitting this item into separate
            items,

            each with their own specific tax amount.
          example: 0
          minimum: 0
          maximum: 99999999
          nullable: true
          default: 0
        external_identifier:
          type: string
          example: item-789123
          description: >-
            An external identifier for the cart item. This can be set to any
            value and is not sent to the payment service.
          nullable: true
          maxLength: 200
        sku:
          type: string
          example: sku-789123
          description: The SKU for the item.
          nullable: true
          maxLength: 200
        product_url:
          type: string
          format: url
          example: https://example.com/items/gopro
          description: The product URL for the item.
          nullable: true
          maxLength: 2083
        image_url:
          type: string
          format: url
          example: https://example.com/images/items/gopro.png
          description: The URL for the image of the item.
          nullable: true
          maxLength: 2083
        categories:
          type: array
          description: |-
            A list of strings containing product categories for the item.
            Max length per item: 50.
          items:
            type: string
            maxLength: 50
          nullable: true
          maxItems: 100
        product_type:
          type: string
          description: The product type of the cart item.
          nullable: true
          example: physical
          enum:
            - physical
            - discount
            - shipping_fee
            - sales_tax
            - digital
            - gift_card
            - store_credit
            - surcharge
            - null
        seller_country:
          type: string
          description: >-
            The country code of the seller of the item. For some connectors, if
            this country code

            does not match the `country` then the transaction will be marked to
            Visa as a foreign

            seller transaction to meet Marketplace reporting requirements.
          example: US
          pattern: ^[A-Z]{2}$
          nullable: true
    GiftCardService--Snapshot:
      title: Gift card service (Snapshot)
      type: object
      description: A snapshot of a gift card service used in a transaction.
      x-tags:
        - Gift Card Services
      properties:
        type:
          type: string
          description: The type of this resource.
          example: gift-card-service
          enum:
            - gift-card-service
        id:
          type: string
          format: uuid
          description: The ID of this gift card service.
          example: 6c020bf3-179b-4f4f-858d-84e39e196e0f
        gift_card_service_definition_id:
          type: string
          description: >
            The ID of the gift card service definition used to create this
            service.
          example: qwikcilver-gift-card
          minLength: 1
          maxLength: 50
        display_name:
          type: string
          description: The custom name set for this service.
          example: Qwikcilver UK
          minLength: 1
          maxLength: 200
    GiftCardRedemption:
      title: Gift card redemption
      type: object
      description: A redemption of a gift card used in a transaction.
      x-tags:
        - Gift Cards
      properties:
        type:
          type: string
          description: The type of this resource.
          example: gift-card-redemption
          enum:
            - gift-card-redemption
        id:
          type: string
          format: uuid
          nullable: true
          description: |-
            The ID of this gift card redemption. This may be `null` if the
            no redemption happened.
          example: bc3f0d5a-3529-4d31-b2b4-848d14926bbc
        status:
          type: string
          description: The status of the gift card redemption for the `payment_method`.
          example: succeeded
          enum:
            - created
            - succeeded
            - failed
            - skipped
        amount:
          type: integer
          description: The amount redeemed for this gift card.
          example: 1299
          minimum: 1
          maximum: 99999999
        refunded_amount:
          type: integer
          description: |-
            The amount refunded for this gift card. This can not be larger
            than `amount`.
          example: 1299
          minimum: 1
          maximum: 99999999
        gift_card_service_redemption_id:
          type: string
          description: The gift card service's unique ID for the redemption.
          example: xYqd43gySMtori
          nullable: true
        error_code:
          description: |-
            If this gift card redemption resulted in an error, this will
            contain the internal code for the error.
          example: expired_card
          nullable: true
          type: string
          enum:
            - expired_card
            - inactive_card
            - incorrect_currency
            - insufficient_funds
            - invalid_amount
            - invalid_gift_card
            - invalid_service_configuration
            - invalid_service_credentials
            - operation_canceled
            - service_error
            - service_network_error
            - unknown_error
        raw_error_code:
          type: string
          description: |-
            If this gift card redemption resulted in an error, this will
            contain the raw error code received from the gift card provider.
          example: '10001'
          nullable: true
        raw_error_message:
          type: string
          description: |-
            If this gift card redemption resulted in an error, this will
            contain the raw error message received from the gift card provider.
          example: Card expired.
          nullable: true
        gift_card:
          $ref: '#/components/schemas/GiftCard--Snapshot'
    PaymentMethod--Snapshot:
      title: Payment method (Snapshot)
      description: |-
        Snapshot of a payment method, as used when embedded inside other
        resources.
      type: object
      x-tags:
        - Payment Methods
      properties:
        type:
          type: string
          description: '`payment-method`.'
          example: payment-method
          enum:
            - payment-method
        id:
          type: string
          description: The unique ID of the payment method.
          format: uuid
          example: 77a76f7e-d2de-4bbc-ada9-d6a0015e6bd5
          nullable: true
        approval_target:
          type: string
          example: any
          nullable: true
          description: >-
            The browser target that an approval URL must be opened in. If `any`
            or `null`, then there is no specific requirement.
          enum:
            - any
            - new_window
        approval_url:
          description: >-
            The optional URL that the buyer needs to be redirected to to further
            authorize their payment.
          example: >-
            https://api.example.app.gr4vy.com/payment-methods/ffc88ec9-e1ee-45ba-993d-b5902c3b2a8c/approve
          format: uri
          nullable: true
          type: string
        country:
          description: |-
            The 2-letter ISO code of the country this payment method can
            be used for. If this value is `null` the payment method may be
            used in multiple countries.
          example: US
          nullable: true
          type: string
        currency:
          description: |-
            The ISO-4217 currency code that this payment method can be
            used for. If this value is `null` the payment method may be
            used for multiple currencies.
          example: USD
          nullable: true
          type: string
        details:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDetailsCard'
          nullable: true
        expiration_date:
          description: >-
            The expiration date for this payment method. This is mostly used by
            cards

            where the card might have an expiration date.
          example: 11/25
          maxLength: 5
          minLength: 5
          nullable: true
          pattern: ^\d{2}/\d{2}$
          type: string
        external_identifier:
          description: |-
            An external identifier that can be used to match the payment method
            against your own records.
          example: user-789123
          nullable: true
          type: string
        label:
          description: >-
            A label for the payment method. This can be the last 4 digits for a
            card,

            or the email address for an alternative payment method.
          example: '1111'
          nullable: true
          type: string
        last_replaced_at:
          description: >-
            The date and time when this card was last replaced.


            When the Account Updater determines that new card details are
            available, existing details are not

            changed immediately. There are three scenarios in which the actual
            replacement occurs:


            1. When this card has expired.

            2. When only the expiration date changed.

            3. When a transaction using this card is declined with any of the
            following codes:
                * `canceled_payment_method`
                * `expired_payment_method`
                * `unavailable_payment_method`
                * `unknown_payment_method`

            When the replacement is applied, this field is updated.

            For non-card payment methods, the value of this field is always set
            to `null`.
          example: '2023-07-26T19:23:00.000+00:00'
          format: date-time
          nullable: true
          type: string
        method:
          description: The type of this payment method.
          type: string
          example: card
          enum:
            - affirm
            - afterpay
            - alipay
            - alipayhk
            - applepay
            - bacs
            - bancontact
            - banked
            - becs
            - bitpay
            - boleto
            - boost
            - card
            - cashapp
            - chaseorbital
            - checkout-session
            - clearpay
            - click-to-pay
            - dana
            - dcb
            - dlocal
            - ebanx
            - efecty
            - eps
            - everydaypay
            - gcash
            - gem
            - gemds
            - gift-card
            - giropay
            - givingblock
            - gocardless
            - googlepay
            - googlepay_pan_only
            - gopay
            - grabpay
            - id
            - ideal
            - kakaopay
            - kcp
            - klarna
            - latitude
            - latitudeds
            - laybuy
            - linepay
            - linkaja
            - maybankqrpay
            - mercadopago
            - multibanco
            - multipago
            - netbanking
            - network-token
            - oney_3x
            - oney_4x
            - oney_6x
            - oney_10x
            - oney_12x
            - ovo
            - oxxo
            - payid
            - paymaya
            - paypal
            - paypalpaylater
            - payto
            - venmo
            - pix
            - pse
            - rabbitlinepay
            - razorpay
            - scalapay
            - sepa
            - shopeepay
            - singteldash
            - smartpay
            - sofort
            - spei
            - stripedd
            - thaiqr
            - touchngo
            - truemoney
            - trustly
            - trustlyeurope
            - upi
            - vipps
            - waave
            - webpay
            - wechat
            - zippay
        payment_account_reference:
          description: >-
            The payment account reference (PAR) returned by the card scheme.
            This is a unique

            reference to the underlying account that has been used to fund this
            payment method.

            This value will be unique if the same underlying account was used,
            regardless of

            the actual payment method used. For example, a network token or an
            Apple Pay device

            token will return the same PAR when possible.


            The uniqueness of this value will depend on the card scheme, please
            refer to their documentation

            for further details. The availability of the PAR in our API depends
            on the availability

            of its value in the API of the payment service used for the
            transaction.
          type: string
          example: V0010014629724763377327521982
          nullable: true
        scheme:
          description: >-
            An additional label used to differentiate different sub-types of a
            payment

            method. Most notably this can include the type of card used in a

            transaction. This field is `null` for the non-card payment methods.

            This represents the card scheme sent to the connector and it could
            be different from the

            actual card scheme that is being used by the PSP to process the
            transaction

            in the following situations: 1. `use_additional_scheme`
            transformation is used

            with the `PAN` instrument but we already have a PSP token for the
            card.

            2. `use_additional_scheme` transformation is used but PSP has fallen
            back to the

            main card scheme internally.
          nullable: true
          type: string
          example: visa
          enum:
            - accel
            - amex
            - bancontact
            - carte-bancaire
            - cirrus
            - culiance
            - dankort
            - diners-club
            - discover
            - eftpos-australia
            - elo
            - hipercard
            - jcb
            - maestro
            - mastercard
            - mir
            - nyce
            - other
            - pulse
            - rupay
            - star
            - uatp
            - unionpay
            - visa
            - null
        fingerprint:
          type: string
          description: >-
            The unique hash derived from the payment method identifier (e.g.
            card number).
          example: 20eb353620155d2b5fc864cc46a73ea77cb92c725238650839da1813fa987a17
          nullable: true
    PaymentService--Snapshot:
      title: A payment service
      type: object
      description: An active, configured payment service.
      x-tags:
        - Payment Services
      properties:
        type:
          type: string
          description: The type of this resource.
          example: payment-service
          enum:
            - payment-service
        id:
          type: string
          description: The ID of this payment service.
          example: stripe-card-faaad066-30b4-4997-a438-242b0752d7e1
          minLength: 1
          maxLength: 200
        display_name:
          description: The custom name set for this service.
          example: Stripe (Main)
          maxLength: 50
          minLength: 1
          type: string
        method:
          description: The payment method that this services handles.
          type: string
          example: card
          enum:
            - affirm
            - afterpay
            - alipay
            - alipayhk
            - applepay
            - bacs
            - bancontact
            - banked
            - becs
            - bitpay
            - boleto
            - boost
            - card
            - cashapp
            - chaseorbital
            - checkout-session
            - clearpay
            - click-to-pay
            - dana
            - dcb
            - dlocal
            - ebanx
            - efecty
            - eps
            - everydaypay
            - gcash
            - gem
            - gemds
            - gift-card
            - giropay
            - givingblock
            - gocardless
            - googlepay
            - googlepay_pan_only
            - gopay
            - grabpay
            - id
            - ideal
            - kakaopay
            - kcp
            - klarna
            - latitude
            - latitudeds
            - laybuy
            - linepay
            - linkaja
            - maybankqrpay
            - mercadopago
            - multibanco
            - multipago
            - netbanking
            - network-token
            - oney_3x
            - oney_4x
            - oney_6x
            - oney_10x
            - oney_12x
            - ovo
            - oxxo
            - payid
            - paymaya
            - paypal
            - paypalpaylater
            - payto
            - venmo
            - pix
            - pse
            - rabbitlinepay
            - razorpay
            - scalapay
            - sepa
            - shopeepay
            - singteldash
            - smartpay
            - sofort
            - spei
            - stripedd
            - thaiqr
            - touchngo
            - truemoney
            - trustly
            - trustlyeurope
            - upi
            - vipps
            - waave
            - webpay
            - wechat
            - zippay
        payment_service_definition_id:
          description: >
            The ID of the payment service definition used to create this
            service.
          example: stripe-card
          maxLength: 50
          minLength: 1
          type: string
    ShippingDetail:
      title: Shipping detail
      type: object
      description: Shipping detail for a buyer.
      x-tags:
        - Buyers
      properties:
        type:
          type: string
          description: The type of this resource. Is always `shipping-details`.
          example: shipping-details
          enum:
            - shipping-details
        id:
          type: string
          format: uuid
          description: The unique ID for a buyer's shipping detail.
          example: 8724fd24-5489-4a5d-90fd-0604df7d3b83
        buyer_id:
          type: string
          format: uuid
          description: The unique ID for a buyer.
          example: 8724fd24-5489-4a5d-90fd-0604df7d3b83
        first_name:
          type: string
          minLength: 1
          maxLength: 255
          description: The first name(s) or given name of the buyer.
          example: John
          nullable: true
        last_name:
          type: string
          minLength: 1
          maxLength: 255
          example: Lunn
          description: The last name, or family name, of the buyer.
          nullable: true
        email_address:
          type: string
          minLength: 1
          maxLength: 320
          description: The email address of the buyer.
          example: john@example.com
          nullable: true
        phone_number:
          type: string
          pattern: ^\+[1-9]\d{1,14}$
          minLength: 1
          maxLength: 50
          description: >-
            The phone number of the buyer. This number is formatted according to
            the

            [E164 number
            standard](https://www.twilio.com/docs/glossary/what-e164).
          example: '+1234567890'
          nullable: true
        address:
          type: object
          description: The physical shipping address associated to this buyer.
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Address'
    StatementDescriptor:
      title: Statement descriptor
      type: object
      description: >-
        The statement descriptor is the text to be shown on the buyer's
        statements.


        The specific usage of these fields will depend on the capabilities of

        the underlying PSP and bank. As a typical example, 'name' and

        'description' could be concatenated using '* ' as a separator, and

        then the resulting descriptor would be truncated to 22 characters by

        the issuing bank.
      properties:
        name:
          type: string
          minLength: 5
          maxLength: 22
          description: |-
            Reflects your doing business as (DBA) name.

            Other validations:

            1. Contains only Latin characters.
            2. Contain at least one letter
            3. Does not contain any of the special characters `< > \ ' " *`
            4. Supports:
              1. Lower case: `a-z`
              2. Upper case: `A-Z`
              3. Numbers: `0-9`
              4. Spaces: ` `
              5. Special characters: `. , _ - ? + /`.
          example: GR4VY
          nullable: true
        description:
          type: string
          minLength: 5
          maxLength: 22
          example: Card payment
          description: |-
            A short description about the purchase.

            Other validations:
            1. Contains only Latin characters.
            2. Contain at least one letter
            3. Does not contain any of the special characters `< > \ ' " *`
            4. Supports:
              1. Lower case: `a-z`
              2. Upper case: `A-Z`
              3. Numbers: `0-9`
              4. Spaces: ` `
              5. Special characters: `. , _ - ? + /`.
          nullable: true
        city:
          type: string
          minLength: 1
          maxLength: 13
          description: |-
            The merchant's city to be displayed in a statement
            descriptor.
          example: London
          nullable: true
        country:
          description: >
            The 2-letter ISO country code of the merchant to be displayed in a
            statement

            descriptor.
          example: US
          nullable: true
          type: string
        phone_number:
          type: string
          pattern: ^\+[1-9]\d{1,14}$
          minLength: 5
          maxLength: 20
          description: >-
            The value in the phone number field of a customer's statement which

            should be formatted according to the

            [E164 number
            standard](https://www.twilio.com/docs/glossary/what-e164).
          example: '+1234567890'
          nullable: true
        url:
          type: string
          minLength: 1
          maxLength: 50
          description: |-
            The merchant's URL to be displayed in a statement
            descriptor.
          example: www.gr4vy.com
          nullable: true
    ThreeDSecureSummary:
      title: 3-D Secure data
      type: object
      description: |-
        The 3-D Secure data that was sent to the payment
        service for the transaction.
      properties:
        version:
          type: string
          description: The version of 3DS used for this transaction.
          pattern: ^[1-2].?[\d+.?]{0,3}$
          example: 2.1.0
        status:
          type: string
          description: The status of the 3DS challenge for this transaction.
          enum:
            - setup_error
            - error
            - declined
            - cancelled
            - complete
        method:
          type: string
          description: The method used for 3DS authentication for this transaction.
          enum:
            - challenge
            - frictionless
        error_data:
          type: object
          nullable: true
          description: |-
            The error data received from our 3DS server. This will not be
            populated if the customer failed the authentication with a
            status code of `N`, `R`, or `U`.  To see full details about
            the 3DS calls in those situations please use our transaction
            events API.
          allOf:
            - $ref: '#/components/schemas/ThreeDSecureError'
        response_data:
          type: object
          nullable: true
          description: |-
            The 3DS data sent to the payment service for this transaction.

            This will only be populated if external 3DS data was passed in
            directly as part of the transaction API call, or if our 3DS server
            returned a status code of `Y` or `A`.

            In case of a failure to authenticate (status `N`, `R`, or `U`) this
            field will not be populated. To see full details about the 3DS calls
            please use our transaction events API.
          x-model-name: ThreeDSecureDataV1V2
          oneOf:
            - $ref: '#/components/schemas/ThreeDSecureDataV1'
            - $ref: '#/components/schemas/ThreeDSecureV2'
    Recipient--Snapshot:
      title: Recipient (Snapshot)
      type: object
      description: >-
        Snapshot of a recipient of an account funding transaction, as used when
        embedded inside other

        resources.
      x-tags:
        - Transactions
      properties:
        first_name:
          type: string
          minLength: 1
          maxLength: 255
          description: The first name(s) or given name for the recipient.
          example: John
          nullable: true
        last_name:
          type: string
          minLength: 1
          maxLength: 255
          example: Lunn
          description: The last name, or family name, of the recipient.
          nullable: true
        address:
          type: object
          description: The billing address for the recipient.
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Address'
            - required:
                - line1
                - city
                - state
                - postal_code
                - country
        account_number:
          type: string
          minLength: 1
          maxLength: 255
          example: '1234567'
          description: >-
            The destination account number to receive an account funding
            transaction.
          nullable: true
        date_of_birth:
          type: string
          description: The recipient's date of birth.
          format: date
          example: '1996-08-31'
          nullable: true
    ErrorDetail:
      title: Error details
      description: Additional detail about the part of a request body that caused an issue.
      type: object
      x-tags:
        - Errors
      properties:
        location:
          type: string
          example: body
          description: The location where the error caused an issue.
          enum:
            - query
            - body
            - path
            - header
        type:
          type: string
          example: value_error.missing
          description: A unique identifier for the type of error that occurred.
        pointer:
          type: string
          example: /payment_method/number
          description: >-
            The exact item for which the validation did not succeed. This is a
            JSON

            pointer for request bodies, while for query, path, and header
            parameters

            it is the name of the parameter.
        message:
          type: string
          example: field required
          description: A human readable message for this error detail.
    AirlinePassenger:
      title: Airline Addendum Passenger
      type: object
      description: Information of the travelling passenger.
      properties:
        title:
          type: string
          minLength: 1
          maxLength: 50
          description: Title of the passenger.
          example: Mr.
          nullable: true
        first_name:
          type: string
          minLength: 1
          maxLength: 255
          description: The first name(s) or given name of the passenger.
          example: John
          nullable: true
        last_name:
          type: string
          minLength: 1
          maxLength: 255
          description: The last name, or family name, of the passenger.
          example: Lunn
          nullable: true
        email_address:
          type: string
          minLength: 1
          maxLength: 320
          description: The email address of the passenger.
          example: john@example.com
          nullable: true
        phone_number:
          type: string
          pattern: ^\+[1-9]\d{1,14}$
          minLength: 1
          maxLength: 50
          description: >-
            The phone number of the passenger. This number is formatted
            according to the

            [E164 number
            standard](https://www.twilio.com/docs/glossary/what-e164).
          example: '+1234567890'
          nullable: true
        passport_number:
          type: string
          minLength: 1
          maxLength: 50
          description: The passenger's unique passport number.
          example: '7700225'
          nullable: true
        ticket_number:
          type: string
          minLength: 1
          maxLength: 50
          description: The ticket number for a flight.
          example: LH1236699999
          nullable: true
        frequent_flyer_number:
          type: string
          minLength: 5
          maxLength: 50
          description: The passenger's frequent flyer number.
          example: '15885566'
          nullable: true
        date_of_birth:
          type: string
          description: The passenger's date of birth.
          format: date
          example: '2013-07-16'
          nullable: true
        age_group:
          type: string
          enum:
            - adult
            - infant
          example: adult
          nullable: true
    AirlineLeg:
      title: Airline Addendum Leg
      type: object
      description: >-
        Each of the separate trip segment, contains detailed itinerary
        information.
      properties:
        carrier_code:
          type: string
          minLength: 2
          maxLength: 2
          description: 2 character airline code as set by IATA.
          example: LY
          nullable: true
        carrier_name:
          type: string
          minLength: 1
          maxLength: 100
          description: The name of the airline.
          example: El Al Israel Airlines
          nullable: true
        iata_designator:
          type: string
          minLength: 2
          maxLength: 2
          description: 2 character IATA code of the airline.
          example: LY
          nullable: true
        icao_code:
          type: string
          minLength: 3
          maxLength: 3
          description: 3 character ICAO code of the airline.
          example: ELY
          nullable: true
        flight_number:
          type: string
          minLength: 3
          maxLength: 6
          description: Unique identifier of the flight number.
          example: BA98
          nullable: true
        departure_at:
          type: string
          format: date-time
          description: The date and time of travel in local time at the departure airport.
          example: '2013-07-16T19:23:00.000+00:00'
          nullable: true
        departure_country:
          type: string
          minLength: 2
          maxLength: 2
          description: Departure country code in ISO 3166 format.
          example: UK
          nullable: true
        departure_city:
          type: string
          minLength: 1
          maxLength: 100
          description: Departure city name.
          example: London
          nullable: true
        departure_airport:
          type: string
          minLength: 3
          maxLength: 3
          description: |-
            Departure airport code of leg. 3-letter ISO code according to IATA
            official directory.
          example: LHR
          nullable: true
        arrival_at:
          type: string
          format: date-time
          description: The date and time of travel in local time at the arrival airport.
          example: '2013-07-16T19:23:00.000+00:00'
          nullable: true
        arrival_country:
          type: string
          minLength: 2
          maxLength: 2
          description: Arrival country code in ISO 3166 format.
          example: UK
          nullable: true
        arrival_city:
          type: string
          minLength: 1
          maxLength: 100
          description: Arrival city name.
          example: London
          nullable: true
        arrival_airport:
          type: string
          minLength: 3
          maxLength: 3
          description: |-
            Arrival airport code of leg. 3-letter ISO code according to IATA
            official directory.
          example: LHR
          nullable: true
        fare_basis_code:
          type: string
          minLength: 1
          maxLength: 8
          description: The alphanumeric code for the "booking class" of a ticket.
          example: WH7LNR
          nullable: true
        flight_class:
          type: string
          minLength: 1
          maxLength: 5
          description: Indicates service class (first class, business class, etc.).
          example: E
          nullable: true
        stop_over:
          type: boolean
          description: Indicates whether a stopover is allowed on this ticket.
          example: false
          nullable: true
        route_type:
          type: string
          description: The route type of the flight.
          enum:
            - round_trip
            - one_way
          example: round_trip
          nullable: false
        coupon_number:
          type: string
          minLength: 1
          maxLength: 50
          description: Coupon number associated with the leg.
          example: '15885566'
          nullable: true
        fare_amount:
          type: integer
          description: >-
            Amount of the ticket, for current leg of the trip, excluding taxes
            and fees.
          minimum: 0
          maximum: 99999999
          example: 100
          nullable: true
        fee_amount:
          type: integer
          description: Fee amount for current leg of the trip.
          minimum: 0
          maximum: 99999999
          example: 100
          nullable: true
        tax_amount:
          type: integer
          description: Amount of the taxes for current leg of the trip.
          minimum: 0
          maximum: 99999999
          example: 100
          nullable: true
        departure_tax_amount:
          type: integer
          description: >-
            Departure tax amount charged by a country when a person is leaving
            the

            country.
          minimum: 0
          maximum: 99999999
          example: 100
          nullable: true
        seat_class:
          type: string
          minLength: 1
          maxLength: 5
          description: Indicates seat class (first class, business class, etc.).
          example: F
          nullable: true
    BillingDetails:
      title: Billing details
      type: object
      description: Billing details associated to a buyer.
      x-tags:
        - Buyers
      properties:
        type:
          type: string
          description: The type of this resource. Is always `billing-details`.
          example: billing-details
          enum:
            - billing-details
        first_name:
          type: string
          minLength: 1
          maxLength: 255
          description: The first name(s) or given name of the buyer.
          example: John
          nullable: true
        last_name:
          type: string
          minLength: 1
          maxLength: 255
          example: Lunn
          description: The last name, or family name, of the buyer.
          nullable: true
        email_address:
          type: string
          minLength: 1
          maxLength: 320
          description: The email address of the buyer.
          example: john@example.com
          nullable: true
        phone_number:
          type: string
          pattern: ^\+[1-9]\d{1,14}$
          minLength: 1
          maxLength: 50
          description: >-
            The phone number of the buyer. This number is formatted according to
            the

            [E164 number
            standard](https://www.twilio.com/docs/glossary/what-e164).
          example: '+1234567890'
          nullable: true
        address:
          description: The billing address of the buyer.
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Address'
        tax_id:
          description: The tax information associated with the billing details.
          nullable: true
          allOf:
            - $ref: '#/components/schemas/TaxId'
    GiftCard--Snapshot:
      title: Gift card (Snapshot)
      type: object
      description: A snapshot of a gift card used in a transaction.
      x-tags:
        - Gift Cards
      properties:
        type:
          type: string
          description: The type of this resource.
          example: gift-card
          enum:
            - gift-card
        id:
          type: string
          format: uuid
          nullable: true
          description: |-
            The ID of this gift card. This may be `null` if the gift
            card is not stored.
          example: e6cdf979-87e2-4796-8ff6-9784d5aed893
        bin:
          type: string
          description: The first 6 digits of the full gift card number.
          example: '412345'
        sub_bin:
          type: string
          description: The 3 digits after the `bin` of the full gift card number.
          example: '554'
        last4:
          type: string
          description: The last 4 digits for the gift card.
          example: '1234'
    PaymentMethodDetailsCard:
      title: Card
      description: A credit or debit card payment method.
      type: object
      x-tags:
        - Payment Methods
      properties:
        bin:
          type: string
          description: The first 6 digits of the full card number (the BIN).
          example: '412345'
        card_type:
          description: The type of card, one of `credit`, `debit` or `prepaid`.
          example: credit
          type: string
          enum:
            - credit
            - debit
            - prepaid
        card_issuer_name:
          type: string
          description: The name of the card issuer.
          example: Bank
    Address:
      title: Address
      type: object
      description: An address for the buyer.
      x-tags:
        - Buyers
      properties:
        city:
          type: string
          minLength: 1
          maxLength: 100
          description: The city for the address.
          example: London
          nullable: true
        country:
          type: string
          minLength: 2
          maxLength: 2
          description: The country for the address in ISO 3166 format.
          example: GB
          nullable: true
        postal_code:
          type: string
          minLength: 1
          maxLength: 50
          description: The postal code or zip code for the address.
          example: '789123'
          nullable: true
        state:
          type: string
          minLength: 1
          maxLength: 255
          description: The state, county, or province for the address.
          example: Greater London
          nullable: true
        state_code:
          type: string
          minLength: 4
          maxLength: 6
          description: |-
            The code of state, county, or province for the address in
            ISO 3166-2 format.
          example: GB-LND
          nullable: true
        house_number_or_name:
          type: string
          minLength: 1
          maxLength: 255
          description: |-
            The house number or name for the address. Not all payment
            services use this field but some do.
          example: '10'
          nullable: true
        line1:
          type: string
          minLength: 1
          maxLength: 255
          description: The first line of the address.
          example: 10 Oxford Street
          nullable: true
        line2:
          type: string
          minLength: 1
          maxLength: 255
          description: The second line of the address.
          example: New Oxford Court
          nullable: true
        organization:
          type: string
          minLength: 1
          maxLength: 255
          description: |-
            The optional name of the company or organisation to add
            to the address.
          example: Gr4vy
          nullable: true
    ThreeDSecureError:
      title: 3-D Secure Error Data
      type: object
      description: Details about the error resulting from 3DS processing a Transaction.
      x-tags:
        - Transactions
      required:
        - description
        - detail
        - component
        - code
      properties:
        description:
          type: string
          description: The error description.
          example: Invalid ThreeDSCompInd
          maxLength: 2048
          nullable: true
        detail:
          type: string
          description: Detail for the error.
          example: The threeDSCompInd must be 'Y' when successful
          maxLength: 2048
          nullable: true
        code:
          type: string
          description: The error code.
          example: '305'
          maxLength: 3
          minLength: 3
          nullable: true
        component:
          type: string
          minLength: 1
          maxLength: 1
          description: Code indicating the 3-D Secure component that identified the error..
          example: C
          nullable: true
    ThreeDSecureDataV1:
      title: 3-D Secure Data Version 1
      type: object
      deprecated: true
      allOf:
        - $ref: '#/components/schemas/ThreeDSecureData'
        - required:
            - authentication_response
            - cavv_algorithm
            - xid
          properties:
            authentication_response:
              type: string
              maxLength: 1
              description: The response for the 3DS authentication call.
              example: 'Y'
            cavv_algorithm:
              type: string
              maxLength: 1
              description: The CAVV algorithm used.
            xid:
              type: string
              description: The transaction identifier.
    ThreeDSecureV2:
      title: 3-D Secure Data Version 2
      type: object
      properties:
        cavv:
          type: string
          description: The cardholder authentication value or AAV.
          example: 3q2+78r+ur7erb7vyv66vv8=
          nullable: true
        eci:
          type: string
          pattern: ^0?\d$
          minLength: 1
          maxLength: 2
          description: The ecommerce indicator for the 3DS transaction.
          example: '05'
          nullable: true
        version:
          type: string
          pattern: ^[1-2].?[\d+.?]{0,3}$
          description: The version of 3-D Secure that was used.
        authentication_response:
          type: string
          maxLength: 1
          description: |-
            The transaction status after a the 3DS challenge. This will
            be null in case of a frictionless 3DS flow.
          example: 'Y'
          nullable: true
          enum:
            - 'Y'
            - A
            - 'N'
            - R
            - U
        directory_response:
          type: string
          maxLength: 1
          description: >-
            The transaction status received as part of the authentication
            request.
          example: C
          enum:
            - C
            - 'Y'
            - A
            - 'N'
            - R
            - U
          nullable: true
        directory_transaction_id:
          type: string
          description: The transaction identifier.
          example: c4e59ceb-a382-4d6a-bc87-385d591fa09d
          nullable: true
        transaction_reason:
          type: string
          description: The reason identifier for a declined transaction.
          nullable: true
          example: '05'
    TaxId:
      title: Tax ID
      type: object
      description: The tax ID information associated to a buyer.
      x-tags:
        - Buyers
      required:
        - kind
        - value
      properties:
        value:
          type: string
          minLength: 1
          maxLength: 50
          description: The tax ID for the buyer.
          example: '12345678931'
        kind:
          type: string
          description: The kind of tax ID.
          example: gb.vat
          enum:
            - ae.trn
            - au.abn
            - ar.dni
            - ar.cuil
            - ar.cuit
            - br.cnpj
            - br.cpf
            - ca.bn
            - ca.gst_hst
            - ca.pst_bc
            - ca.pst_mb
            - ca.pst_sk
            - ca.qst
            - ch.vat
            - cl.tin
            - es.cif
            - eu.vat
            - gb.vat
            - hk.br
            - id.nik
            - id.npwp
            - in.gst
            - jp.cn
            - jp.rn
            - kr.brn
            - li.uid
            - mx.curp
            - my.frp
            - my.itn
            - my.nric
            - my.sst
            - no.vat
            - nz.gst
            - ph.tin
            - ru.inn
            - ru.kpp
            - sa.vat
            - sg.gst
            - sg.uen
            - th.id
            - th.vat
            - tw.vat
            - us.ein
            - za.vat
    ThreeDSecureData:
      title: 3-D Secure Data
      type: object
      required:
        - cavv
        - eci
        - version
        - directory_response
      properties:
        cavv:
          type: string
          description: The cardholder authentication value or AAV.
          example: 3q2+78r+ur7erb7vyv66vv8=
        eci:
          type: string
          pattern: ^0?\d$
          minLength: 1
          maxLength: 2
          description: The ecommerce indicator for the 3DS transaction.
          example: '05'
        version:
          type: string
          pattern: ^[1-2].?[\d+.?]{0,3}$
          description: The version of 3-D Secure that was used.
        directory_response:
          type: string
          maxLength: 1
          description: >-
            For 3-D Secure version 1, the enrolment response. For 3-D Secure
            version , the transaction status from the `ARes`.
          example: C
        scheme:
          type: string
          description: The scheme/brand of the card that is used for 3-D Secure.
          nullable: true
          example: visa
          enum:
            - accel
            - amex
            - bancontact
            - carte-bancaire
            - cirrus
            - culiance
            - dankort
            - diners-club
            - discover
            - eftpos-australia
            - elo
            - hipercard
            - jcb
            - maestro
            - mastercard
            - mir
            - nyce
            - other
            - pulse
            - rupay
            - star
            - uatp
            - unionpay
            - visa
            - null
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````